
#include <windows.h>
#include "physmem.h"



#define LIBRARY_NAME                           L"physmem.dll"
#define MAP_PHYSICAL_MEMORY_FUNCTION_NAME      "MapPhysicalMemory"
#define UNMAP_PHYSICAL_MEMORY_FUNCTION_NAME    "UnmapPhysicalMemory"



typedef BOOL (WINAPI MAPPHYSICALMEMORY)(PSIZE_T Size, PLARGE_INTEGER Offset, PVOID *Address);
typedef BOOL (WINAPI UNMAPPHYSICALMEMORY)(PVOID Address);


static HANDLE hLibrary = NULL;
static MAPPHYSICALMEMORY *_MapPhysicalMemory = NULL;
static UNMAPPHYSICALMEMORY *_UnmapPhysicalMemory = NULL;




PVOID PhysMemMapMemory(PSIZE_T Size, PLARGE_INTEGER Offset)
{
  PVOID Ret = NULL;

  if (_MapPhysicalMemory != NULL) {
    if (!_MapPhysicalMemory(Size, Offset, &Ret))
      Ret = NULL;
  }

  return Ret;
}


BOOL PhysMemUnmapMemory(PVOID Address)
{
  BOOL Ret = FALSE;

  if (_UnmapPhysicalMemory != NULL)
    Ret = _UnmapPhysicalMemory(Address);

  return Ret;
}



BOOL PhysMemModuleInit(VOID)
{
  BOOL Ret = FALSE;

  hLibrary = LoadLibraryW(LIBRARY_NAME);
  Ret = hLibrary != NULL;
  if (Ret) {
    _MapPhysicalMemory = (MAPPHYSICALMEMORY *)GetProcAddress(hLibrary, MAP_PHYSICAL_MEMORY_FUNCTION_NAME);
	_UnmapPhysicalMemory = (UNMAPPHYSICALMEMORY *)GetProcAddress(hLibrary, UNMAP_PHYSICAL_MEMORY_FUNCTION_NAME);
    Ret = (_MapPhysicalMemory != NULL && _UnmapPhysicalMemory != NULL);
    if (!Ret)
      FreeLibrary(hLibrary);
  }

  return Ret;
}


VOID PhysMemModuleFinit(VOID)
{
  _MapPhysicalMemory = NULL;
  _UnmapPhysicalMemory = NULL;
  FreeLibrary(hLibrary);
  hLibrary = NULL;

  return;
}