
#ifndef __TESTS_H_
#define __TESTS_H_

#include <windows.h>



typedef struct _TEST_SET {
  RTL_CRITICAL_SECTION CritSec;
  LIST_ENTRY ListHead;
} TEST_SET, *PTEST_SET;



PTEST_SET TestSetCreate(VOID);
VOID TestSetFree(PTEST_SET TestSet);

BOOL CreatePrivateMemoryAllocationTestAction(PTEST_SET TestSet, PVOID BaseAddress);
BOOL CreatePagingFileSectionTestAction(PTEST_SET TestSet, HANDLE SectionHandle, PVOID BaseAddress);
BOOL CreateMappedFileTestAction(PTEST_SET TestSet, HANDLE FileHandle, HANDLE SectionHandle, PVOID BaseAddress);
BOOL CreateAweTestAction(PTEST_SET TestSet, PULONG_PTR PageNumbers, ULONG_PTR PageCount, PVOID BaseAddress);
BOOL CreateSecuredRegionTestAction(PVOID TestSet, HANDLE SecureHandle);
BOOL CreateDevicePhysicalMemoryTestAction(PTEST_SET TestSet, PVOID BaseAddress);



#endif
